require "resources/essentialmode/lib/MySQL"

MySQL:open(database.host, database.name, database.username, database.password)

-- Vérifier la quantité d'item sur le joueur pour la production
RegisterServerEvent('job:CheckItemQuantityToUser')
AddEventHandler('job:CheckItemQuantityToUser',
  function(recolte, traitement)
    TriggerEvent("es:getPlayerFromId", source,
      function(user)
	  
		local resultRecolt = 0
		local resultTraitement = 0
	  
		local executed_query = MySQL:executeQuery("SELECT quantity FROM user_inventory WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(recolte), ['@identifier'] = user.identifier}) -- ON RECUPERE LA QUANTITE DE L'ITEM --
		local resultR = MySQL:getResults(executed_query, {'quantity'})	
		
		local executed_query2 = MySQL:executeQuery("SELECT quantity FROM user_inventory WHERE item_id = '@itemId' AND user_id ='@identifier'", {['@itemId'] = tonumber(traitement), ['@identifier'] = user.identifier}) -- ON RECUPERE LA QUANTITE DE L'ITEM --
		local resultT = MySQL:getResults(executed_query2, {'quantity'})			
		
		if resultR[1] ~= nil then
			resultRecolt = tonumber(resultR[1].quantity)
		end
		
		if resultT[1] ~= nil then
			resultTraitement = tonumber(resultT[1].quantity)
		end
		
		TriggerClientEvent('job:ResultOfQuantityItem', source, resultRecolt, resultTraitement)
		end
    )
  end
)
	

function GetItemNameById(itemId)
	local myTable = MySQL:executeQuery("SELECT name_singulier FROM items WHERE id = '@id'", {['@id'] = itemId})
	local queryMyTable = MySQL:getResults(myTable, {'name_singulier'})	
		
	return queryMyTable[1].name_singulier
end

-- Envoyer les blips concernant Récolte / Traitement / Revente / Vehicule
RegisterServerEvent('job:setBlipsForJob')
AddEventHandler('job:setBlipsForJob', function(jobName)
	TriggerEvent("es:getPlayerFromId", source,
      function(user)
		
		local job = getJobIdByName(jobName)
		local entreprise = getEntrepriseId(job)
		
		local myTable = MySQL:executeQuery("SELECT * FROM j_productions")
		local queryMyTable = MySQL:getResults(myTable, {'id', 'entreprise_id', 'recolte_cords', 'traitement_cords', 'revente_cords', 'vehicle_cords', 'item_recolte_id', 'item_traitement_id', 'prix_revente'})	 
		
		local myTable2 = MySQL:executeQuery("SELECT vehicule FROM j_entreprises WHERE id = '@id'", {['@id'] = entreprise})
		local queryMyTable2 = MySQL:getResults(myTable2, {'vehicule'})	
		
		for _, v in pairs(queryMyTable)do
			if v.entreprise_id == entreprise then
				local RecoltePos = json.decode(v.recolte_cords)
				local TraitementPos = json.decode(v.traitement_cords)
				local ReventePos = json.decode(v.revente_cords)
				local VehiclePos = json.decode(v.vehicle_cords)
				local RecolteItem = v.item_recolte_id
				local TraitementItem = v.item_traitement_id		
				local RecolteItemName = GetItemNameById(v.item_recolte_id)			
				local TraitementItemName = GetItemNameById(v.item_traitement_id)
				local ItemSellPrice = v.prix_revente
		
				t = {
					["Vehicule"] = { 
						id=17, 
						title="Vehicule",
						r=155, 
						g=89, 
						b=182, 
						name=jobName.." : vehicule",
						vehicle_name=queryMyTable2[1].vehicule,
						x=VehiclePos[1], 
						y=VehiclePos[2], 
						z=VehiclePos[3] 
					},				
					["Recolte"] = { 
						id=18, 
						title="Récolte", 
						r=52, 
						g=152, 
						b=219, 
						name=jobName.." : récolte", 
						item_t=TraitementItem,
						item_r=RecolteItem,
						item_r_name=RecolteItemName,
						x=RecoltePos[1], 
						y=RecoltePos[2], 
						z=RecoltePos[3] 
					}, 
					["Traitement"] = { 
						id=19, 
						title="Traitement", 
						r=241, 
						g=196, 
						b=15, 
						name=jobName.." : traitement", 
						item_t=TraitementItem,
						item_r=RecolteItem,
						item_t_name=TraitementItemName,
						item_r_name=RecolteItemName,
						x=TraitementPos[1], 
						y=TraitementPos[2], 
						z=TraitementPos[3] 
					}, 
					["Revente"] = { 
						id=20, 
						title="Revente", 
						r=46, 
						g=204, 
						b=113, 
						name=jobName.." : revente",	
						item_t=TraitementItem,
						item_r=RecolteItem,
						item_t_name=TraitementItemName,
						price=ItemSellPrice,
						x=ReventePos[1], 
						y=ReventePos[2], 
						z=ReventePos[3] 
					}	
				}
				
			end
		end
		TriggerClientEvent("job:drawBlipsForJob", source, t) -- Blips à l'entreprise
		TriggerClientEvent("job:drawMarkerProduction", source, t)
	end
	)
end
)

-- Lancement du skin pour le joueur
RegisterServerEvent('job:loadSkinByJob')
AddEventHandler('job:loadSkinByJob', function(jobName)
	TriggerEvent("es:getPlayerFromId", source,
      function(user)
		
		local job = getJobIdByName(jobName)
		
		local executed_query = MySQL:executeQuery("SELECT componentid, drawableid, textureid, paletteid FROM j_tenues WHERE job_id = '@job_id'", {['@job_id'] = job})
		local querySkinJob = MySQL:getResults(executed_query, {'componentid', 'drawableid', 'textureid', 'paletteid'})
		
		if(querySkinJob ~= nil) then
			TriggerClientEvent('job:setSkinByJob', source, querySkinJob)
		end
		
	end
	)
end
)


-- Information lors de la connexion
AddEventHandler('es:playerLoaded', function(source)
	TriggerEvent('es:getPlayerFromId', source, function(user)
		local playerJobID = getJobId(user.identifier)
		local playerJobName = getJobName(playerJobID)
		blips = { }
		TriggerClientEvent("job:updateJobHud", source, playerJobName) -- Chargé le HUD pour le métier à la connexion
		user:addMoney(0)
		user:addDirty_Money(0)
		
		if playerJobID > 1 and playerJobID < 11 then
			if getEntrepriseId(playerJobID) ~= nil then
				local monEntreprise = getEntrepriseId(playerJobID)
				local executed_query = MySQL:executeQuery("SELECT Nom, positionXYZ FROM j_entreprises WHERE id = '@id'", {['@id'] = monEntreprise})
				local result = MySQL:getResults(executed_query, {'positionXYZ', 'Nom'})
				if(result)then
					for _, v in ipairs(result)do
						if v.positionXYZ ~= "" then
						-- Décodage des données récupérées
						local entreprisePos = json.decode(v.positionXYZ)
						t = { ["title"] = v.Nom, ["colour"] = 0, ["id"] = 350, ["x"] = entreprisePos[1], ["y"] = entreprisePos[2], ["z"] = entreprisePos[3]}
						table.insert(blips, t)
						-- On envoie la position vers le client pour le blips
						end
					end
					TriggerClientEvent("job:drawBlips", source, blips)	-- Blips à l'entreprise
					TriggerClientEvent("job:drawMarkerEntreprise", source, blips) -- Marker à l'entreprise
				end
			end
		end
	end)
end)

-- Récupérer la position de l'entreprise
RegisterServerEvent('job:getPos')
AddEventHandler('job:getPos', function(jobId)
	TriggerEvent("es:getPlayerFromId", source, function(user)
		blips = { }
		--Récupération du SteamID.
		local player = user.identifier
		--Récupération du EntrepriseID
		local entrepriseId = getEntrepriseId(jobId)
		--Exécution de la requêtes SQL.
		local executed_query = MySQL:executeQuery("SELECT Nom, positionXYZ FROM j_entreprises WHERE id = '@id'", {['@id'] = entrepriseId})
		--Récupération des données générée par la requête.
		local result = MySQL:getResults(executed_query, {'positionXYZ', 'Nom'})
		-- Vérification de la présence d'un résultat avant de lancer le traitement.
		if(result)then
			for _, v in ipairs(result)do
				if v.positionXYZ ~= "" then
				-- Décodage des données récupérées
				local entreprisePos = json.decode(v.positionXYZ)
				t = { ["title"] = v.Nom, ["colour"] = 0, ["id"] = 350, ["x"] = entreprisePos[1], ["y"] = entreprisePos[2], ["z"] = entreprisePos[3]}
				table.insert(blips, t)
				-- On envoie la position vers le client pour le blips
				end
			end				
			TriggerClientEvent("job:drawBlips", source, blips) -- Blips à l'entreprise
			TriggerClientEvent("job:drawBlipsMission", source, blips) -- Trajet pour aller à l'entreprise
			TriggerClientEvent("job:drawMarkerEntreprise", source, blips) -- Marker à l'entreprise
			
		end
	end
	)
end
)

-- Vérifie si le joueur est un Chômeur
RegisterServerEvent('job:getChomage')
AddEventHandler('job:getChomage', function()
	TriggerEvent("es:getPlayerFromId", source,
      function(user)
	  
		local executed_query = MySQL:executeQuery("SELECT job FROM users WHERE identifier = '@identifier'", {['@identifier'] = user.identifier})
		local queryJob = MySQL:getResults(executed_query, {'job'})
		
		if(queryJob ~= nil) then
			TriggerClientEvent('job:setChomage', source, queryJob[1].job)
		end
		
	end
	)
end
)

-- Récupérer la liste des métiers
RegisterServerEvent('job:getListJob')
AddEventHandler('job:getListJob', function()
	TriggerEvent("es:getPlayerFromId", source,
      function(user)
	  
	    local executed_query = MySQL:executeQuery("SELECT job_id, job_name FROM jobs")
		local queryJob = MySQL:getResults(executed_query, {'job_id', 'job_name'})
		
		if(queryJob ~= nil) then
			TriggerClientEvent('job:setJobList', source, queryJob)
		end
		
	end
	)
end
)

-- Mettre à jour le métier de l'utilisateur
RegisterServerEvent('job:newJob')
AddEventHandler('job:newJob', function(id)
	TriggerEvent("es:getPlayerFromId", source,
	function(user)
		local jobName = getJobName(id)
		if id ~= 1 then
			TriggerClientEvent("es_freeroam:notify", source, "CHAR_PLANESITE", 1, "Entreprise", false, "Les coordonnées ~b~GPS ~w~de l'entreprise vous ont été envoyés.")	
		end
		MySQL:executeQuery("UPDATE users SET job = '@value' WHERE identifier = '@id'", {['@id'] = user.identifier, ['@value'] = id})
		TriggerClientEvent('job:updateJobHud', source, jobName)
	end
	)
end
)

-- Récupérer l'entreprise ID en fonction du job ID
function getEntrepriseId(jId)
	local executed_query = MySQL:executeQuery("SELECT id FROM j_entreprises WHERE job_id = '@job_id'", {['@job_id'] = jId})
	local queryJobId = MySQL:getResults(executed_query, {'id'})
	
	if(queryJobId ~= nil) then
		return queryJobId[1].id
	end
end

-- Récupérer le job id
function getJobId(identifier)
	local executed_query = MySQL:executeQuery("SELECT job FROM users WHERE identifier = '@identifier'", {['@identifier'] = identifier})
	local queryJob = MySQL:getResults(executed_query, {'job'})
	
	return queryJob[1].job
end

-- Récupérer le job name par l'id
function getJobName(jobId)
	local executed_query = MySQL:executeQuery("SELECT job_name FROM jobs WHERE job_id = '@job_id'", {['@job_id'] = jobId})
	local queryJobName = MySQL:getResults(executed_query, {'job_name'})
	
	return queryJobName[1].job_name
end

-- Récupérer le job id par le nom
function getJobIdByName(name)
	local executed_query = MySQL:executeQuery("SELECT job_id FROM jobs WHERE job_name = '@job_name'", {['@job_name'] = name})
	local queryJobName = MySQL:getResults(executed_query, {'job_id'})
	
	return queryJobName[1].job_id
end